// Generated by CoffeeScript 1.12.2
(function() {
  var abbrs, assembly, calculator, copper, courtyard, getAbbr, silkscreen, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  assembly = require('./common/assembly');

  calculator = require('./common/calculator');

  copper = require('./common/copper');

  courtyard = require('./common/courtyard');

  silkscreen = require('./common/silkscreen');

  abbrs = {
    CAP: 'capacitor',
    IND: 'inductor',
    RES: 'resistor'
  };

  getAbbr = function(element) {
    var abbr, k, keywords, v;
    abbr = 'U';
    if (element.keywords == null) {
      return name;
    }
    keywords = element.keywords.toLowerCase().replace(/\s+/g, '').split(',');
    for (k in abbrs) {
      v = abbrs[k];
      if (keywords.indexOf(v) !== -1) {
        abbr = k;
        break;
      }
    }
    return abbr;
  };

  module.exports = function(pattern, element) {
    var abbr, housing, padParams, settings;
    settings = pattern.settings;
    housing = element.housing;
    if (housing.leadSpan == null) {
      housing.leadSpan = housing.bodyWidth;
    }
    abbr = getAbbr(element);
    abbr += 'CA';
    if (housing.concave) {
      abbr += 'V';
    } else if (housing['convex-e']) {
      abbr += 'XE';
    } else if (housing['convex-s']) {
      abbr += 'XS';
    } else if (housing.flat) {
      abbr += 'F';
    }
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["%s%dP%dX%dX%d-%d%s", abbr].concat(slice.call([housing.pitch * 100, housing.bodyLength.nom * 100, housing.bodyWidth.nom * 100, housing.height.max * 100, housing.leadCount].map((function(_this) {
        return function(v) {
          return Math.round(v);
        };
      })(this))), [settings.densityLevel]));
    }
    padParams = calculator.chipArray(pattern, housing);
    padParams.order = 'round';
    padParams.pad = {
      type: 'smd',
      shape: 'rectangle',
      width: padParams.width,
      height: padParams.height,
      layer: ['topCopper', 'topMask', 'topPaste']
    };
    copper.dual(pattern, element, padParams);
    silkscreen.dual(pattern, housing);
    assembly.body(pattern, housing);
    return courtyard.dual(pattern, housing, padParams.courtyard);
  };

}).call(this);
