// Generated by CoffeeScript 1.12.2
(function() {
  module.exports = {
    body: function(pattern, housing) {
      var bodyLength, bodyWidth, x, y;
      bodyWidth = housing.bodyWidth.nom;
      bodyLength = housing.bodyLength.nom;
      x = bodyWidth / 2;
      y = bodyLength / 2;
      return this.preamble(pattern, housing).rectangle(-x, -y, x, y);
    },
    pak: function(pattern, element) {
      var bodyLength, bodyWidth, housing, i, j, leadCount, leadSpan, pins, ref, ref1, ref2, results, tabLedge, tabWidth, x1, x2, y;
      housing = element.housing;
      bodyWidth = housing.bodyWidth.nom;
      bodyLength = housing.bodyLength.nom;
      leadSpan = housing.leadSpan.nom;
      leadCount = housing.leadCount;
      tabLedge = (ref = housing.tabLedge.nom) != null ? ref : housing.tabLedge;
      tabWidth = (ref1 = housing.tabWidth.nom) != null ? ref1 : housing.tabWidth;
      x1 = leadSpan / 2 - tabLedge;
      x2 = x1 - bodyWidth;
      this.preamble(pattern, housing).rectangle(x1, -bodyLength / 2, x2, bodyLength / 2).rectangle(x1, -tabWidth / 2, x1 + tabLedge, tabWidth / 2);
      pins = element.pins;
      y = -housing.pitch * (leadCount / 2 - 0.5);
      results = [];
      for (i = j = 1, ref2 = leadCount; 1 <= ref2 ? j <= ref2 : j >= ref2; i = 1 <= ref2 ? ++j : --j) {
        if (pins[i] != null) {
          pattern.line(-leadSpan / 2, y, x2, y);
        }
        results.push(y += housing.pitch);
      }
      return results;
    },
    polarized: function(pattern, housing) {
      var bodyLength, bodyWidth, d, x, y;
      bodyWidth = housing.bodyWidth.nom;
      bodyLength = housing.bodyLength.nom;
      x = bodyWidth / 2;
      y = bodyLength / 2;
      d = Math.min(1, bodyWidth / 2, bodyLength / 2);
      return this.preamble(pattern, housing).moveTo(-x + d, -y).lineTo(x, -y).lineTo(x, y).lineTo(-x, y).lineTo(-x, -y + d).lineTo(-x + d, -y);
    },
    preamble: function(pattern, housing) {
      var angle, fontSize, h, lineWidth, maxFontSize, settings, textLineWidth, w;
      settings = pattern.settings;
      w = housing.bodyWidth != null ? housing.bodyWidth.nom : housing.bodyDiameter.nom;
      h = housing.bodyLength != null ? housing.bodyLength.nom : housing.bodyDiameter.nom;
      lineWidth = settings.lineWidth.assembly;
      angle = w < h ? 90 : 0;
      fontSize = settings.fontSize["default"];
      maxFontSize = 0.66 * Math.min(w, h);
      if (fontSize > maxFontSize) {
        fontSize = maxFontSize;
      }
      textLineWidth = Math.min(lineWidth, fontSize / 5);
      return pattern.layer('topAssembly').lineWidth(textLineWidth).attribute('value', {
        text: pattern.name,
        x: 0,
        y: 0,
        angle: angle,
        fontSize: fontSize,
        halign: 'center',
        valign: 'center'
      }).attribute('user', {
        text: 'REF**',
        x: 0,
        y: 0,
        angle: angle,
        fontSize: fontSize,
        halign: 'center',
        valign: 'center',
        visible: false
      }).lineWidth(lineWidth);
    },
    twoPin: function(pattern, housing) {
      var bodyLength, bodyWidth, d, diam, lineWidth, ref, settings, x, y;
      settings = pattern.settings;
      lineWidth = settings.lineWidth.assembly;
      this.preamble(pattern, housing);
      if ((housing.bodyWidth != null) && (housing.bodyLength != null)) {
        bodyWidth = housing.bodyWidth.nom;
        bodyLength = housing.bodyLength.nom;
        x = bodyWidth / 2;
        y = bodyLength / 2;
        if (housing.cae) {
          d = Math.min(bodyWidth / 4, bodyLength / 4);
          diam = (ref = housing.bodyDiameter.nom) != null ? ref : housing.bodyDiameter;
          pattern.moveTo(-x + d, -y).lineTo(-x, -y + d).lineTo(-x, y).lineTo(x, y).lineTo(x, -y + d).lineTo(x - d, -y).lineTo(-x + d, -y);
          if (diam != null) {
            return pattern.circle(0, 0, diam / 2);
          }
        } else if (housing.polarized) {
          return this.polarized(pattern, housing);
        } else {
          return pattern.rectangle(-x, -y, x, y);
        }
      } else if (housing.bodyDiameter != null) {
        return pattern.circle(0, 0, housing.bodyDiameter.nom / 2);
      }
    }
  };

}).call(this);
