// Generated by CoffeeScript 1.12.2
(function() {
  var assembly, calculator, copper, courtyard, silkscreen, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  assembly = require('./assembly');

  calculator = require('./calculator');

  copper = require('./copper');

  courtyard = require('./courtyard');

  silkscreen = require('./silkscreen');

  module.exports = function(pattern, element) {
    var abbr, hasTab, housing, leadCount, option, padParams, settings;
    housing = element.housing;
    settings = pattern.settings;
    leadCount = housing.leadCount;
    hasTab = (housing.tabWidth != null) && (housing.tabLength != null);
    if (hasTab) {
      ++leadCount;
    }
    if (housing.cfp) {
      abbr = 'CFP';
      option = 'sop';
    } else if (housing.flatlead) {
      abbr = 'SOPFL';
      option = 'flatlead';
    } else if (housing.soic) {
      abbr = 'SOIC';
      option = 'sop';
    } else if (housing.soj) {
      abbr = 'SOJ';
      option = 'soj';
    } else if (housing.sol) {
      abbr = 'SOL';
      option = 'sol';
    } else if (housing.son) {
      abbr = 'SON';
      option = 'son';
    } else {
      abbr = 'SOP';
      option = 'sop';
    }
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["%s%dP%dX%d-%d%s", abbr].concat(slice.call([housing.pitch * 100, housing.leadSpan.nom * 100, housing.height.max * 100, leadCount].map((function(_this) {
        return function(v) {
          return Math.round(v);
        };
      })(this))), [settings.densityLevel]));
    }
    padParams = calculator.dual(pattern, housing, option);
    padParams.order = 'round';
    padParams.pad = {
      type: 'smd',
      shape: 'rectangle',
      width: padParams.width,
      height: padParams.height,
      layer: ['topCopper', 'topMask', 'topPaste']
    };
    copper.dual(pattern, element, padParams);
    silkscreen.dual(pattern, housing);
    if (housing.polarized) {
      assembly.polarized(pattern, housing);
    } else {
      assembly.body(pattern, housing);
    }
    courtyard.dual(pattern, housing, padParams.courtyard);
    return copper.tab(pattern, element);
  };

}).call(this);
