// Generated by CoffeeScript 1.12.2
(function() {
  var assembly, calculator, copper, copperPads, courtyard, mountingHole, pinNumber, silkscreen;

  assembly = require('./common/assembly');

  calculator = require('./common/calculator');

  copper = require('./common/copper');

  courtyard = require('./common/courtyard');

  silkscreen = require('./common/silkscreen');

  pinNumber = 0;

  mountingHole = 1;

  copperPads = function(pattern, element, suffix) {
    var column, columnCount, columnCounts, columnDX, columnDXs, columnDY, columnDYs, hasPads, holeDiameter, horizontalPitch, housing, i, j, k, l, len, number, numbers, p, pad, padDiameter, padHeight, padWidth, pins, points, ref, ref1, ref10, ref11, ref12, ref13, ref14, ref15, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref9, row, rowCount, rowDX, rowDXs, rowDY, rowDYs, verticalPitch, x, y;
    if (suffix == null) {
      suffix = '';
    }
    housing = element.housing;
    pins = element.pins;
    numbers = Object.keys(pins);
    if (!((housing['holeDiameter' + suffix] != null) || ((housing['padWidth' + suffix] != null) && (housing['padHeight' + suffix] != null)))) {
      return false;
    }
    hasPads = false;
    if (housing['holeDiameter' + suffix] != null) {
      holeDiameter = housing['holeDiameter' + suffix];
      padDiameter = (ref = housing['padDiameter' + suffix]) != null ? ref : calculator.padDiameter(pattern, housing, holeDiameter);
      padWidth = (ref1 = housing['padWidth' + suffix]) != null ? ref1 : padDiameter;
      padHeight = (ref2 = housing['padHeight' + suffix]) != null ? ref2 : padDiameter;
      pad = {
        type: 'through-hole',
        hole: housing['holeDiameter' + suffix],
        width: padWidth,
        height: padHeight,
        shape: !pinNumber ? 'rectangle' : 'circle',
        layer: ['topCopper', 'topMask', 'topPaste', 'bottomCopper', 'bottomMask', 'bottomPaste']
      };
      if ((padWidth < holeDiameter) || (padHeight < holeDiameter)) {
        pad.type = 'mounting-hole';
        pad.layer = ['topCopper', 'topMask', 'bottomCopper', 'bottomMask'];
        pad.width = holeDiameter;
        pad.height = holeDiameter;
        pad.shape = 'circle';
      }
    } else {
      padDiameter = housing['padDiameter' + suffix];
      padWidth = (ref3 = housing['padWidth' + suffix]) != null ? ref3 : padDiameter;
      padHeight = (ref4 = housing['padHeight' + suffix]) != null ? ref4 : padDiameter;
      pad = {
        type: 'smd',
        width: housing['padWidth' + suffix],
        height: housing['padHeight' + suffix],
        shape: padDiameter != null ? 'circle' : 'rectangle',
        layer: ['topCopper', 'topMask', 'topPaste']
      };
    }
    if (housing['padPosition' + suffix] != null) {
      hasPads = true;
      points = pattern.parsePosition(housing['padPosition' + suffix]);
      for (i = j = 0, len = points.length; j < len; i = ++j) {
        p = points[i];
        pad.x = p.x;
        pad.y = p.y;
        number = pad.type === 'mounting-hole' ? 'MH' + mountingHole++ : (ref5 = numbers[pinNumber++]) != null ? ref5 : 'NC';
        pattern.pad(number, pad);
        if (housing['holeDiameter' + suffix] != null) {
          pad.shape = 'circle';
        }
      }
    } else if ((housing['rowCount' + suffix] != null) && (housing['columnCount' + suffix] != null)) {
      hasPads = true;
      rowCount = housing['rowCount' + suffix];
      if (rowCount === 1) {
        verticalPitch = 0;
      } else {
        verticalPitch = (ref6 = housing['verticalPitch' + suffix]) != null ? ref6 : housing['pitch' + suffix];
      }
      rowDXs = pattern.parseArray(housing['rowDX' + suffix]);
      rowDYs = pattern.parseArray(housing['rowDY' + suffix]);
      columnCounts = pattern.parseArray(housing['columnCount' + suffix]);
      horizontalPitch = (ref7 = housing['horizontalPitch' + suffix]) != null ? ref7 : housing['pitch' + suffix];
      columnDXs = pattern.parseArray(housing['columnDX' + suffix]);
      columnDYs = pattern.parseArray(housing['columnDY' + suffix]);
      y = -verticalPitch * (rowCount - 1) / 2;
      for (row = k = 0, ref8 = rowCount - 1; 0 <= ref8 ? k <= ref8 : k >= ref8; row = 0 <= ref8 ? ++k : --k) {
        columnCount = (ref9 = columnCounts[row]) != null ? ref9 : columnCounts[0];
        rowDX = (ref10 = rowDXs[row]) != null ? ref10 : rowDXs[0];
        rowDY = (ref11 = rowDYs[row]) != null ? ref11 : rowDYs[0];
        x = -horizontalPitch * (columnCount - 1) / 2;
        for (column = l = 0, ref12 = columnCount - 1; 0 <= ref12 ? l <= ref12 : l >= ref12; column = 0 <= ref12 ? ++l : --l) {
          columnDX = (ref13 = columnDXs[column]) != null ? ref13 : columnDXs[0];
          columnDY = (ref14 = columnDYs[column]) != null ? ref14 : columnDYs[0];
          pad.x = x + rowDX + columnDX;
          pad.y = y + rowDY + columnDY;
          number = pad.type === 'mounting-hole' ? 'MH' + mountingHole++ : (ref15 = numbers[pinNumber++]) != null ? ref15 : 'NC';
          pattern.pad(number, pad);
          if (housing['holeDiameter' + suffix] != null) {
            pad.shape = 'circle';
          }
          x += horizontalPitch;
        }
        y += verticalPitch;
      }
    }
    return hasPads;
  };

  module.exports = function(pattern, element) {
    var bodyPosition, housing, i;
    housing = element.housing;
    if (pattern.name == null) {
      pattern.name = element.group + '_' + element.name.toUpperCase();
    }
    if (housing.bodyPosition == null) {
      housing.bodyPosition = '0, 0';
    }
    bodyPosition = pattern.parsePosition(housing.bodyPosition);
    pattern.center(-bodyPosition[0].x, -bodyPosition[0].y);
    pinNumber = 0;
    mountingHole = 1;
    copperPads(pattern, element);
    i = 1;
    while (true) {
      if (!copperPads(pattern, element, i++)) {
        break;
      }
    }
    pattern.center(0, 0);
    copper.mask(pattern);
    silkscreen.body(pattern, housing);
    if (housing.polarized) {
      assembly.polarized(pattern, housing);
    } else {
      assembly.body(pattern, housing);
    }
    return courtyard.boundary(pattern, housing);
  };

}).call(this);
