// Generated by CoffeeScript 1.12.2
(function() {
  var assembly, calculator, copper, courtyard, silkscreen, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  assembly = require('./common/assembly');

  calculator = require('./common/calculator');

  copper = require('./common/copper');

  courtyard = require('./common/courtyard');

  silkscreen = require('./common/silkscreen');

  module.exports = function(pattern, element) {
    var housing, i, j, leadCount, pad, padParams, pins, pitch, ref, settings, y;
    housing = element.housing;
    settings = pattern.settings;
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["TO%dP%dX%dX%d-%d%s"].concat(slice.call([housing.pitch * 100, housing.bodyLength.nom * 100, housing.bodyWidth.nom * 100, housing.height.max * 100, housing.leadCount].map((function(_this) {
        return function(v) {
          return Math.round(v);
        };
      })(this))), [settings.densityLevel]));
    }
    padParams = calculator.pak(pattern, housing);
    pad = {
      type: 'smd',
      shape: 'rectangle',
      width: padParams.width1,
      height: padParams.height1,
      layer: ['topCopper', 'topMask', 'topPaste']
    };
    pitch = housing.pitch;
    leadCount = housing.leadCount;
    pins = element.pins;
    pad.x = -padParams.distance1 / 2;
    y = -pitch * (leadCount / 2 - 0.5);
    for (i = j = 1, ref = leadCount; 1 <= ref ? j <= ref : j >= ref; i = 1 <= ref ? ++j : --j) {
      pad.y = y;
      if (pins[i] != null) {
        pattern.pad(i, pad);
      }
      y += pitch;
    }
    pad.width = padParams.width2;
    pad.height = padParams.height2;
    pad.x = padParams.distance2 / 2;
    pad.y = 0;
    pattern.pad(leadCount + 1, pad);
    copper.mask(pattern);
    silkscreen.pak(pattern, housing);
    assembly.pak(pattern, element);
    return courtyard.pak(pattern, housing, padParams.courtyard);
  };

}).call(this);
