// Generated by CoffeeScript 1.12.2
(function() {
  var assembly, calculator, copper, courtyard, silkscreen, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  assembly = require('./common/assembly');

  calculator = require('./common/calculator');

  copper = require('./common/copper');

  courtyard = require('./common/courtyard');

  silkscreen = require('./common/silkscreen');

  module.exports = function(pattern, element) {
    var housing, i, j, leftCount, pad, padParams, ref, settings, y;
    housing = element.housing;
    housing.polarized = true;
    settings = pattern.settings;
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["SOT%s%dP%dX%d-%d%s", housing.flatlead ? 'FL' : ''].concat(slice.call([housing.pitch * 100, housing.leadSpan.nom * 100, housing.height.max * 100, housing.leadCount].map((function(_this) {
        return function(v) {
          return Math.round(v);
        };
      })(this))), [settings.densityLevel]));
    }
    padParams = calculator.sot(pattern, housing);
    pad = {
      type: 'smd',
      shape: 'rectangle',
      width: padParams.width1,
      height: padParams.height1,
      layer: ['topCopper', 'topMask', 'topPaste']
    };
    leftCount = housing.leadCount - 1;
    pad.x = -padParams.distance / 2;
    y = -housing.pitch * (leftCount / 2 - 0.5);
    for (i = j = 1, ref = leftCount; 1 <= ref ? j <= ref : j >= ref; i = 1 <= ref ? ++j : --j) {
      pad.y = y;
      pattern.pad(i, pad);
      y += housing.pitch;
    }
    pad.x = padParams.distance / 2;
    pad.y = 0;
    pad.width = padParams.width2;
    pad.height = padParams.height2;
    pattern.pad(leftCount + 1, pad);
    copper.mask(pattern);
    silkscreen.dual(pattern, housing);
    assembly.polarized(pattern, housing);
    return courtyard.dual(pattern, housing, padParams.courtyard);
  };

}).call(this);
