// Generated by CoffeeScript 1.12.2
(function() {
  var assembly, calculator, copper, courtyard, log, silkscreen, sop, sprintf,
    slice = [].slice;

  sprintf = require('sprintf-js').sprintf;

  assembly = require('./common/assembly');

  calculator = require('./common/calculator');

  copper = require('./common/copper');

  courtyard = require('./common/courtyard');

  silkscreen = require('./common/silkscreen');

  sop = require('./sop');

  log = require('../../qeda-log');

  module.exports = function(pattern, element) {
    var housing, i, j, k, leftCount, leftPitch, pad, padParams, ref, ref1, rightCount, rightPitch, settings, y;
    housing = element.housing;
    housing.polarized = true;
    settings = pattern.settings;
    if (pattern.name == null) {
      pattern.name = sprintf.apply(null, ["SOT%s%dP%dX%d-%d%s", housing.flatlead ? 'FL' : ''].concat(slice.call([housing.pitch * 100, housing.leadSpan.nom * 100, housing.height.max * 100, housing.leadCount].map((function(_this) {
        return function(v) {
          return Math.round(v);
        };
      })(this))), [settings.densityLevel]));
    }
    if ((housing.leadCount % 2) === 0) {
      return sop(pattern, element);
    } else {
      padParams = calculator.dual(pattern, housing, 'sop');
      switch (housing.leadCount) {
        case 3:
          leftCount = 2;
          leftPitch = housing.pitch * 2;
          rightCount = 1;
          rightPitch = housing.pitch;
          break;
        case 5:
          leftCount = 3;
          leftPitch = housing.pitch;
          rightCount = 2;
          rightPitch = housing.pitch * 2;
          break;
        default:
          log.error("Wrong lead count (" + housing.leadCount + ")");
      }
      pad = {
        type: 'smd',
        shape: 'rectangle',
        width: padParams.width,
        height: padParams.height,
        layer: ['topCopper', 'topMask', 'topPaste']
      };
      pad.x = -padParams.distance / 2;
      y = -leftPitch * (leftCount / 2 - 0.5);
      for (i = j = 1, ref = leftCount; 1 <= ref ? j <= ref : j >= ref; i = 1 <= ref ? ++j : --j) {
        pad.y = y;
        pattern.pad(i, pad);
        y += leftPitch;
      }
      pad.x = padParams.distance / 2;
      y = rightPitch * (rightCount / 2 - 0.5);
      for (i = k = 1, ref1 = rightCount; 1 <= ref1 ? k <= ref1 : k >= ref1; i = 1 <= ref1 ? ++k : --k) {
        pad.y = y;
        pattern.pad(leftCount + i, pad);
        y -= rightPitch;
      }
      copper.mask(pattern);
      silkscreen.dual(pattern, housing);
      assembly.polarized(pattern, housing);
      return courtyard.dual(pattern, housing, padParams.courtyard);
    }
  };

}).call(this);
