// Generated by CoffeeScript 1.12.2
(function() {
  var QedaSymbol,
    slice = [].slice,
    hasProp = {}.hasOwnProperty;

  QedaSymbol = (function() {
    function QedaSymbol(element, name1, part) {
      var both, delta, group, groups, j, k, l, len, len1, pinGroup, pins, ref, schematic, side, sides, toBottom, toLeft, toRight, toTop, v;
      this.name = name1;
      this.settings = element.library.symbol;
      this.shapes = [];
      this.attributes = [];
      this.currentLineWidth = 0;
      sides = ['left', 'right', 'top', 'bottom'];
      schematic = element.schematic;
      pins = element.pins;
      if (part != null) {
        this.part = {};
        ref = element.pinGroups;
        for (k in ref) {
          v = ref[k];
          if (part.indexOf(k) !== -1) {
            this.part[k] = v;
          }
        }
      }
      for (j = 0, len = sides.length; j < len; j++) {
        side = sides[j];
        this[side] = [];
        if (schematic[side] != null) {
          groups = element.parseMultiple(schematic[side]);
          if (part != null) {
            groups = groups.filter((function(_this) {
              return function(v) {
                return part.indexOf(v) !== -1;
              };
            })(this));
          }
          for (l = 0, len1 = groups.length; l < len1; l++) {
            group = groups[l];
            if (element.pinGroups[group] != null) {
              pinGroup = element.pinGroups[group];
              if (this[side].length && (!schematic.simpified)) {
                this[side].push('-');
              }
              this[side] = this[side].concat(pinGroup);
            }
          }
        }
      }
      both = this.left.filter((function(_this) {
        return function(v) {
          return (v !== '-') && (_this.right.indexOf(v) !== -1);
        };
      })(this));
      delta = Math.ceil((this.right.length - this.left.length + both.length) / 2);
      toLeft = both.slice(0, +(delta - 1) + 1 || 9e9);
      toRight = both.slice(delta);
      this.left = this.left.filter((function(_this) {
        return function(v) {
          return toRight.indexOf(v) === -1;
        };
      })(this));
      this.right = this.right.filter((function(_this) {
        return function(v) {
          return toLeft.indexOf(v) === -1;
        };
      })(this));
      both = this.top.filter((function(_this) {
        return function(v) {
          return (v !== '-') && (_this.bottom.indexOf(v) !== -1);
        };
      })(this));
      delta = Math.ceil((this.bottom.length - this.top.length + both.length) / 2);
      toTop = both.slice(0, +(delta - 1) + 1 || 9e9);
      toBottom = both.slice(delta);
      this.top = this.top.filter((function(_this) {
        return function(v) {
          return toBottom.indexOf(v) === -1;
        };
      })(this));
      this.bottom = this.bottom.filter((function(_this) {
        return function(v) {
          return toTop.indexOf(v) === -1;
        };
      })(this));
      if (schematic.simpified) {
        if (schematic.showPinNames == null) {
          schematic.showPinNames = false;
        }
      }
      this.x = 0;
      this.y = 0;
      this.cx = 0;
      this.cy = 0;
    }

    QedaSymbol.prototype.alignToGrid = function(n, method) {
      if (method == null) {
        method = 'round';
      }
      return Math[method](n / this.settings.gridSize) * this.settings.gridSize;
    };

    QedaSymbol.prototype.arc = function(x, y, radius, start, end) {
      this._addShape('arc', {
        x: this.cx + x,
        y: this.cy + y,
        radius: radius,
        start: start,
        end: end
      });
      return this;
    };

    QedaSymbol.prototype.arrow = function(x1, y1, x2, y2, width) {
      var a, x11, x12, y11, y12;
      a = Math.atan((y2 - y1) / (x2 - x1));
      x11 = x1 + width * Math.sin(a) / 2;
      y11 = y1 - width * Math.cos(a) / 2;
      x12 = x1 - width * Math.sin(a) / 2;
      y12 = y1 + width * Math.cos(a) / 2;
      return this.poly(x11, y11, x2, y2, x12, y12, 'background');
    };

    QedaSymbol.prototype.attribute = function(name, attribute) {
      var ref;
      attribute.name = name;
      if (attribute.fontSize == null) {
        attribute.fontSize = (ref = this.settings.fontSize[name]) != null ? ref : this.settings.fontSize["default"];
      }
      this.attributes[name] = this._addShape('attribute', attribute);
      return this;
    };

    QedaSymbol.prototype.center = function(x, y) {
      this.cx = x;
      this.cy = y;
      return this;
    };

    QedaSymbol.prototype.circle = function(x, y, radius, fill) {
      if (fill == null) {
        fill = 'none';
      }
      this._addShape('circle', {
        x: this.cx + x,
        y: this.cy + y,
        radius: radius,
        fill: fill
      });
      return this;
    };

    QedaSymbol.prototype.dot = function(x, y) {
      this._addShape('line', {
        x1: this.cx + x,
        y1: this.cy + y,
        x2: this.cx + x,
        y2: this.cy + y
      });
      return this;
    };

    QedaSymbol.prototype.icon = function(x, y, iconObj) {
      iconObj.draw(x, y);
      return this;
    };

    QedaSymbol.prototype.invertVertical = function() {
      var j, l, len, len1, prop, props, ref, results, shape;
      props = ['y', 'y1', 'y2', 'height'];
      ref = this.shapes;
      results = [];
      for (j = 0, len = ref.length; j < len; j++) {
        shape = ref[j];
        for (l = 0, len1 = props.length; l < len1; l++) {
          prop = props[l];
          if (shape[prop] != null) {
            shape[prop] *= -1;
          }
        }
        if (shape['points'] != null) {
          results.push(shape['points'] = shape['points'].map(function(v, i) {
            if (i % 2 === 1) {
              return -v;
            } else {
              return v;
            }
          }));
        } else {
          results.push(void 0);
        }
      }
      return results;
    };

    QedaSymbol.prototype.line = function(x1, y1, x2, y2) {
      if ((x1 !== x2) || (y1 !== y2)) {
        this._addShape('line', {
          x1: this.cx + x1,
          y1: this.cy + y1,
          x2: this.cx + x2,
          y2: this.cy + y2
        });
      }
      return this;
    };

    QedaSymbol.prototype.lineTo = function(x, y) {
      this.line(this.x, this.y, x, y);
      return this.moveTo(x, y);
    };

    QedaSymbol.prototype.lineWidth = function(lineWidth) {
      this.currentLineWidth = lineWidth;
      return this;
    };

    QedaSymbol.prototype.moveTo = function(x, y) {
      this.x = x;
      this.y = y;
      return this;
    };

    QedaSymbol.prototype.pin = function(pin) {
      if (pin.fontSize == null) {
        pin.fontSize = this.settings.fontSize.pin;
      }
      if (pin.space == null) {
        pin.space = this.settings.space.pin;
      }
      pin.x = this.cx + pin.x;
      pin.y = this.cy + pin.y;
      this._addShape('pin', pin);
      return this;
    };

    QedaSymbol.prototype.poly = function() {
      var count, fill, i, j, l, points, ref;
      points = 2 <= arguments.length ? slice.call(arguments, 0, j = arguments.length - 1) : (j = 0, []), fill = arguments[j++];
      count = points.length / 2;
      for (i = l = 0, ref = count - 1; 0 <= ref ? l <= ref : l >= ref; i = 0 <= ref ? ++l : --l) {
        points[2 * i] = this.cx + points[2 * i];
        points[2 * i + 1] = this.cy + points[2 * i + 1];
      }
      if ((points[0] !== points[points.length - 2]) && (points[1] !== points[points.length - 1])) {
        points.push(points[0]);
        points.push(points[1]);
      }
      this._addShape('poly', {
        points: points,
        fill: fill
      });
      return this;
    };

    QedaSymbol.prototype.polyline = function() {
      var points;
      points = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      return this.poly.apply(this, slice.call(points).concat(['none']));
    };

    QedaSymbol.prototype.rectangle = function(x1, y1, x2, y2, fill) {
      if (fill == null) {
        fill = 'none';
      }
      this._addShape('rectangle', {
        x1: this.cx + x1,
        y1: this.cy + y1,
        x2: this.cx + x2,
        y2: this.cy + y2,
        fill: fill
      });
      return this;
    };

    QedaSymbol.prototype.resize = function(gridSize, needRound) {
      var factor, j, l, len, len1, prop, props, ref, results, shape, value;
      if (needRound == null) {
        needRound = false;
      }
      factor = gridSize / this.settings.gridSize;
      props = ['x', 'x1', 'x2', 'y', 'y1', 'y2', 'width', 'height', 'length', 'lineWidth', 'fontSize', 'space', 'radius'];
      ref = this.shapes;
      results = [];
      for (j = 0, len = ref.length; j < len; j++) {
        shape = ref[j];
        for (l = 0, len1 = props.length; l < len1; l++) {
          prop = props[l];
          if (shape[prop] != null) {
            value = shape[prop] * factor;
            if (needRound) {
              value = Math.round(value);
            }
            shape[prop] = value;
          }
        }
        if (shape['points'] != null) {
          shape['points'] = shape['points'].map(function(v) {
            return v * factor;
          });
          if (needRound) {
            results.push(shape['points'] = shape['points'].map(function(v) {
              return Math.round(v);
            }));
          } else {
            results.push(void 0);
          }
        } else {
          results.push(void 0);
        }
      }
      return results;
    };

    QedaSymbol.prototype.text = function(text) {
      if (text.fontSize == null) {
        text.fontSize = this.settings.fontSize["default"];
      }
      if (text.angle == null) {
        text.angle = 0;
      }
      this._addShape('text', text);
      return this;
    };

    QedaSymbol.prototype.textWidth = function(text, textType) {
      if (textType == null) {
        textType = 'default';
      }
      return this.settings.fontSize[textType] * text.length;
    };

    QedaSymbol.prototype._addShape = function(kind, shape) {
      var obj, prop;
      obj = {
        kind: kind
      };
      for (prop in shape) {
        if (!hasProp.call(shape, prop)) continue;
        obj[prop] = shape[prop];
      }
      if (obj.lineWidth == null) {
        obj.lineWidth = this.currentLineWidth;
      }
      this.shapes.push(obj);
      return obj;
    };

    return QedaSymbol;

  })();

  module.exports = QedaSymbol;

}).call(this);
