// Generated by CoffeeScript 1.12.2
(function() {
  var intersects, pinTextWidth;

  intersects = function(s1, s2) {
    var a1, a2, a3, a4;
    a1 = (s1[0] >= s2[0]) && (s1[0] <= s2[1]);
    a2 = (s1[1] >= s2[0]) && (s1[1] <= s2[1]);
    a3 = (s2[0] >= s1[0]) && (s2[0] <= s1[1]);
    a4 = (s2[1] >= s1[0]) && (s2[1] <= s1[1]);
    return a1 || a2 || a3 || a4;
  };

  pinTextWidth = function(symbol, pin, space, visible) {
    if (visible) {
      return symbol.textWidth(pin.name, 'pin') + space;
    } else {
      return 0;
    }
  };

  module.exports = function(symbol, element, icon) {
    var attributeSpace, bottom, bottomPins, bottomRects, bottomY, dx, dy, h, height, i, i1, j, j1, k, k1, l, left, leftPins, leftRects, leftX, len, len1, len10, len11, len12, len13, len14, len15, len2, len3, len4, len5, len6, len7, len8, len9, m, n, o, p, pin, pinIconHeight, pinIconWidth, pinLength, pinSpace, pins, pitch, q, r, rect, rects, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref9, right, rightPins, rightX, s, schematic, settings, space, t, top, topPins, topRects, topY, u, v, w, width, x, x1, x2, y, y1, y2, z;
    schematic = element.schematic;
    settings = symbol.settings;
    pitch = symbol.alignToGrid(settings.pitch);
    pinLength = symbol.alignToGrid((ref = settings.pinLength) != null ? ref : 10);
    pinSpace = (ref1 = schematic.pinSpace) != null ? ref1 : settings.space.pin;
    space = settings.space["default"];
    left = symbol.left;
    right = symbol.right;
    top = symbol.top;
    bottom = symbol.bottom;
    pins = element.pins;
    width = pitch * (Math.max(top.length, bottom.length) + 1);
    height = pitch * (Math.max(left.length, right.length) + 1);
    leftX = -width / 2;
    rightX = width / 2;
    topY = -height / 2;
    bottomY = height / 2;
    rects = [];
    if (icon != null) {
      rects.push({
        x1: ((ref2 = icon.x1) != null ? ref2 : -icon.width / 2) - space,
        y1: ((ref3 = icon.y1) != null ? ref3 : -icon.height / 2) - space,
        x2: ((ref4 = icon.x2) != null ? ref4 : icon.width / 2) + space,
        y2: ((ref5 = icon.y2) != null ? ref5 : icon.height / 2) + space
      });
    }
    for (j = 0, len = rects.length; j < len; j++) {
      rect = rects[j];
      if (leftX > rect.x1) {
        leftX = rect.x1;
      }
      if (rightX < rect.x2) {
        rightX = rect.x2;
      }
      if (topY > rect.y1) {
        topY = rect.y1;
      }
      if (bottomY < rect.y2) {
        bottomY = rect.y2;
      }
    }
    if (schematic.pinIcon != null) {
      pinSpace += schematic.pinIcon.width;
      pinIconWidth = schematic.pinIcon.width;
      pinIconHeight = schematic.pinIcon.height;
    }
    dx = settings.fontSize.pin / 2 + space;
    y = topY;
    if ((schematic.pinIcon != null) && top.length) {
      y -= schematic.pinIcon.height;
    }
    topPins = [];
    topRects = [];
    x = -pitch * (top.length / 2 - 0.5);
    for (k = 0, len1 = top.length; k < len1; k++) {
      i = top[k];
      if (i === '-') {
        x += pitch;
        continue;
      }
      pin = pins[i];
      if (pin == null) {
        continue;
      }
      pin.x = x;
      pin.length = pinLength;
      pin.orientation = 'down';
      topPins.push(pin);
      h = pinTextWidth(symbol, pin, pinSpace, schematic.showPinNames);
      if (y > (-h - space)) {
        y = -h - space;
      }
      x1 = x - dx;
      x2 = x + dx;
      for (l = 0, len2 = rects.length; l < len2; l++) {
        r = rects[l];
        if (intersects([x1, x2], [r.x1, r.x2])) {
          y1 = r.y1 - h - space;
          if (y > y1) {
            y = y1;
          }
        }
      }
      x += pitch;
      topRects.push({
        x1: x1,
        y1: 0,
        x2: x2,
        y2: h
      });
    }
    topY = symbol.alignToGrid(y, 'floor');
    for (m = 0, len3 = topRects.length; m < len3; m++) {
      r = topRects[m];
      r.y1 += topY;
      r.y2 += topY;
      rects.push(r);
    }
    y = bottomY;
    if ((schematic.pinIcon != null) && bottom.length) {
      y += schematic.pinIcon.height;
    }
    bottomPins = [];
    bottomRects = [];
    x = -pitch * (bottom.length / 2 - 0.5);
    for (n = 0, len4 = bottom.length; n < len4; n++) {
      i = bottom[n];
      if (i === '-') {
        x += pitch;
        continue;
      }
      pin = pins[i];
      if (pin == null) {
        continue;
      }
      pin.x = x;
      pin.length = pinLength;
      pin.orientation = 'up';
      bottomPins.push(pin);
      h = pinTextWidth(symbol, pin, pinSpace, schematic.showPinNames);
      if (y < (h + space)) {
        y = h + space;
      }
      x1 = x - dx;
      x2 = x + dx;
      for (o = 0, len5 = rects.length; o < len5; o++) {
        r = rects[o];
        if (intersects([x1, x2], [r.x1, r.x2])) {
          y2 = r.y2 + h + space;
          if (y < y2) {
            y = y2;
          }
        }
      }
      x += pitch;
      bottomRects.push({
        x1: x1,
        y1: -h,
        x2: x2,
        y2: 0
      });
    }
    bottomY = symbol.alignToGrid(y, 'ceil');
    for (p = 0, len6 = bottomRects.length; p < len6; p++) {
      r = bottomRects[p];
      r.y1 += bottomY;
      r.y2 += bottomY;
      rects.push(r);
    }
    x = leftX;
    if ((schematic.pinIcon != null) && left.length) {
      x -= schematic.pinIcon.width;
    }
    if (top.length > 0) {
      w = symbol.textWidth('U???', 'refDes');
      if (x > (-w - space)) {
        x = -w - space;
      }
    }
    dy = settings.fontSize.pin / 2 + space;
    leftPins = [];
    leftRects = [];
    y = -pitch * (left.length / 2 - 0.5);
    for (q = 0, len7 = left.length; q < len7; q++) {
      i = left[q];
      if (i === '-') {
        y += pitch;
        continue;
      }
      pin = pins[i];
      if (pin == null) {
        continue;
      }
      pin.y = y;
      pin.length = pinLength;
      pin.orientation = 'right';
      leftPins.push(pin);
      w = pinTextWidth(symbol, pin, pinSpace, schematic.showPinNames);
      if (x > (-w - space)) {
        x = -w - space;
      }
      y1 = y - dy;
      y2 = y + dy;
      for (s = 0, len8 = rects.length; s < len8; s++) {
        r = rects[s];
        if (intersects([y1, y2], [r.y1, r.y2])) {
          x1 = r.x1 - w - space;
          if (x > x1) {
            x = x1;
          }
        }
      }
      y += pitch;
      leftRects.push({
        x1: 0,
        y1: y1,
        x2: w,
        y2: y2
      });
    }
    leftX = symbol.alignToGrid(x, 'floor');
    for (t = 0, len9 = leftRects.length; t < len9; t++) {
      r = leftRects[t];
      r.x1 += leftX;
      r.x2 += leftX;
      rects.push(r);
    }
    x = rightX;
    if ((schematic.pinIcon != null) && right.length) {
      x += schematic.pinIcon.width;
    }
    rightPins = [];
    y = -pitch * (right.length / 2 - 0.5);
    for (u = 0, len10 = right.length; u < len10; u++) {
      i = right[u];
      if (i === '-') {
        y += pitch;
        continue;
      }
      pin = pins[i];
      if (pin == null) {
        continue;
      }
      pin.y = y;
      pin.length = pinLength;
      pin.orientation = 'left';
      rightPins.push(pin);
      w = pinTextWidth(symbol, pin, pinSpace, schematic.showPinNames);
      if (x < (w + space)) {
        x = w + space;
      }
      y1 = y - dy;
      y2 = y + dy;
      for (v = 0, len11 = rects.length; v < len11; v++) {
        r = rects[v];
        if (intersects([y1, y2], [r.y1, r.y2])) {
          x2 = r.x2 + w + space;
          if (x < x2) {
            x = x2;
          }
        }
      }
      y += pitch;
    }
    rightX = symbol.alignToGrid(x, 'ceil');
    if (schematic.symmetrical && (top.length || bottom.length)) {
      x = Math.max(-leftX, rightX);
      leftX = -x;
      rightX = x;
    }
    width = rightX - leftX;
    height = bottomY - topY;
    width = symbol.alignToGrid(width, 'ceil');
    height = symbol.alignToGrid(height, 'ceil');
    symbol.lineWidth(settings.lineWidth.thick).rectangle(0, 0, width, height, settings.fill);
    if (icon != null) {
      icon.draw(-leftX, -topY);
    }
    for (z = 0, len12 = leftPins.length; z < len12; z++) {
      pin = leftPins[z];
      pin.x = -pinLength;
      pin.y -= topY;
      pin.space = pinSpace;
      symbol.pin(pin);
      if ((ref6 = schematic.pinIcon) != null) {
        ref6.draw(pin.x + pinLength + pinIconWidth / 2, pin.y);
      }
    }
    for (i1 = 0, len13 = rightPins.length; i1 < len13; i1++) {
      pin = rightPins[i1];
      pin.x = width + pinLength;
      pin.y -= topY;
      pin.space = pinSpace;
      symbol.pin(pin);
      if ((ref7 = schematic.pinIcon) != null) {
        ref7.draw(pin.x - pinLength - pinIconWidth / 2, pin.y);
      }
    }
    for (j1 = 0, len14 = topPins.length; j1 < len14; j1++) {
      pin = topPins[j1];
      pin.x -= leftX;
      pin.y = -pinLength;
      pin.space = pinSpace;
      symbol.pin(pin);
      if ((ref8 = schematic.pinIcon) != null) {
        ref8.draw(pin.x, pin.y + pinLength + pinIconHeight / 2);
      }
    }
    for (k1 = 0, len15 = bottomPins.length; k1 < len15; k1++) {
      pin = bottomPins[k1];
      pin.x -= leftX;
      pin.y = height + pinLength;
      pin.space = pinSpace;
      symbol.pin(pin);
      if ((ref9 = schematic.pinIcon) != null) {
        ref9.draw(pin.x, pin.y - pinLength - pinIconHeight / 2);
      }
    }
    attributeSpace = settings.space.attribute;
    if (element.parts != null) {
      return symbol.attribute('refDes', {
        x: 0,
        y: -settings.fontSize.name - 2 * attributeSpace,
        halign: 'left',
        valign: 'bottom'
      }).attribute('name', {
        x: 0,
        y: -attributeSpace,
        halign: 'left',
        valign: 'bottom'
      });
    } else {
      if (topPins.length > 0) {
        symbol.attribute('refDes', {
          x: 0,
          y: -attributeSpace,
          halign: 'left',
          valign: 'bottom'
        });
      } else {
        symbol.attribute('refDes', {
          x: width / 2,
          y: -attributeSpace,
          halign: 'center',
          valign: 'bottom'
        });
      }
      if (bottomPins.length > 0) {
        return symbol.attribute('name', {
          x: bottomPins[bottomPins.length - 1].x + attributeSpace,
          y: height + attributeSpace,
          halign: 'left',
          valign: 'top'
        });
      } else {
        return symbol.attribute('name', {
          x: width / 2,
          y: height + attributeSpace,
          halign: 'center',
          valign: 'top'
        });
      }
    }
  };

}).call(this);
