// Generated by CoffeeScript 1.12.2
(function() {
  var enclosure;

  enclosure = require('./enclosure');

  module.exports = function(symbol, element, icon, leftName, rightName) {
    var bottomY, decorated, groups, height, i, j, k, l, left, leftRegEx, len, len1, len2, m, nc, needEnclosure, pin, pinAreaHeight, pinLength1, pinLength2, pins, pitch, ref, ref1, ref2, ref3, results, right, rightRegEx, schematic, settings, topY, v, width, y;
    if (leftName == null) {
      leftName = 'L';
    }
    if (rightName == null) {
      rightName = 'R';
    }
    schematic = element.schematic;
    settings = symbol.settings;
    pins = element.pins;
    if (schematic.showPinNames == null) {
      schematic.showPinNames = false;
    }
    leftRegEx = new RegExp("^" + leftName);
    rightRegEx = new RegExp("^" + rightName);
    groups = (ref = symbol.part) != null ? ref : element.pinGroups;
    for (k in groups) {
      v = groups[k];
      k = k.toUpperCase();
      if (k.match(leftRegEx)) {
        left = v.map((function(_this) {
          return function(e) {
            return pins[e];
          };
        })(this));
      } else if (k.match(rightRegEx)) {
        right = v.map((function(_this) {
          return function(e) {
            return pins[e];
          };
        })(this));
      } else if (k.match(/^NC/)) {
        nc = v.map((function(_this) {
          return function(e) {
            return pins[e];
          };
        })(this));
      } else if (k === '') {
        continue;
      } else {
        needEnclosure = true;
      }
    }
    if (left == null) {
      left = [
        {
          name: leftName,
          number: 1
        }
      ];
    }
    if (right == null) {
      right = [
        {
          name: rightName,
          number: 2
        }
      ];
    }
    if (needEnclosure) {
      schematic.showPinNames = true;
      schematic.showPinNumbers = true;
      return enclosure(symbol, element, icon);
    } else {
      decorated = (left.length > 1) || (right.length > 1) || (nc != null ? nc.length : void 0);
      if (schematic.showPinNumbers == null) {
        schematic.showPinNumbers = decorated ? true : false;
      }
      width = icon.width;
      height = icon.height;
      pinLength2 = symbol.alignToGrid((ref1 = settings.pinLength) != null ? ref1 : (decorated ? 5 : 2.5), 'ceil');
      pinLength1 = (2 * symbol.alignToGrid(width / 2 + pinLength2, 'ceil') - width) / 2;
      pitch = symbol.alignToGrid(settings.pitch);
      pinAreaHeight = (Math.max(left.length, right.length) - 1) * pitch;
      topY = (ref2 = icon.y1) != null ? ref2 : -height / 2;
      bottomY = (ref3 = icon.y2) != null ? ref3 : height / 2;
      symbol.attribute('refDes', {
        x: 0,
        y: topY - settings.space.attribute,
        halign: 'center',
        valign: 'bottom'
      }).attribute('name', {
        x: 0,
        y: Math.max(bottomY, pinAreaHeight / 2) + settings.space.attribute,
        halign: 'center',
        valign: 'top'
      });
      icon.draw(0, 0);
      if (left.length === 1) {
        symbol.pin({
          number: left[0].number,
          name: left[0].name,
          x: -width / 2 - pinLength1,
          y: 0,
          length: pinLength1,
          orientation: 'right',
          passive: true
        });
      } else {
        y = -pitch * (left.length - 1) / 2;
        symbol.line(-width / 2 - pinLength1, 0, -width / 2, 0).line(-width / 2 - pinLength1, y, -width / 2 - pinLength1, -y);
        for (j = 0, len = left.length; j < len; j++) {
          pin = left[j];
          pin.x = -width / 2 - pinLength1 - pinLength2;
          pin.y = y;
          pin.length = pinLength2;
          pin.orientation = 'right';
          pin.passive = true;
          symbol.pin(pin);
          y += pitch;
        }
      }
      if (right.length === 1) {
        symbol.pin({
          number: right[0].number,
          name: right[0].name,
          x: width / 2 + pinLength1,
          y: 0,
          length: pinLength1,
          orientation: 'left',
          passive: true
        });
      } else {
        y = -pitch * (right.length - 1) / 2;
        symbol.line(width / 2, 0, width / 2 + pinLength1, 0).line(width / 2 + pinLength1, y, width / 2 + pinLength1, -y);
        for (l = 0, len1 = right.length; l < len1; l++) {
          pin = right[l];
          pin.x = width / 2 + pinLength1 + pinLength2;
          pin.y = y;
          pin.length = pinLength2;
          pin.orientation = 'left';
          pin.passive = true;
          symbol.pin(pin);
          y += pitch;
        }
      }
      if (nc != null) {
        results = [];
        for (i = m = 0, len2 = nc.length; m < len2; i = ++m) {
          pin = nc[i];
          pin.x = (i - (nc.length - 1) / 2) * pitch;
          pin.y = Math.max(height, pinAreaHeight) / 2 + pinLength2;
          pin.length = pinLength2;
          pin.orientation = 'up';
          pin.nc = true;
          pin.invisible = true;
          results.push(symbol.pin(pin));
        }
        return results;
      }
    }
  };

}).call(this);
