// Generated by CoffeeScript 1.12.2
(function() {
  var Icons, enclosure;

  enclosure = require('./common/enclosure');

  Icons = require('./common/icons');

  module.exports = function(symbol, element, icons) {
    var height, icon, k, left, middle, names, needEnclosure, pinGroups, pinLength, pins, r, ref, right, rotateLeft, rotateRight, schematic, settings, space, v, valid, width, x1, x2;
    if (icons == null) {
      icons = Icons;
    }
    element.refDes = 'D';
    schematic = element.schematic;
    settings = symbol.settings;
    pins = element.pins;
    pinGroups = element.pinGroups;
    icon = new icons.Diode(symbol, element);
    if (schematic.showPinNames == null) {
      schematic.showPinNames = false;
    }
    if (schematic.showPinNumbers == null) {
      schematic.showPinNumbers = true;
    }
    rotateLeft = false;
    rotateRight = false;
    names = Object.keys(pinGroups);
    for (k in pins) {
      v = pins[k];
      switch (v.name) {
        case 'A':
          if (names.indexOf('C1') !== -1) {
            rotateLeft = true;
            middle = v;
          } else {
            left = v;
          }
          break;
        case 'A1':
          left = v;
          break;
        case 'A2':
          right = v;
          break;
        case 'A3':
          middle = v;
          break;
        case 'AC':
          middle = v;
          break;
        case 'C':
          if (names.indexOf('A1') !== -1) {
            rotateRight = true;
            middle = v;
          } else {
            right = v;
          }
          break;
        case 'C1':
          left = v;
          break;
        case 'C2':
          right = v;
          break;
        case 'CA':
          middle = v;
          break;
        default:
          needEnclosure = true;
      }
    }
    valid = (left != null) && (middle != null) && (right != null);
    if ((!valid) || needEnclosure) {
      schematic.showPinNames = true;
      schematic.showPinNumbers = true;
      return enclosure(symbol, element, icon);
    } else {
      space = settings.space["default"];
      width = 2 * icon.width + 4 * space;
      width = 2 * symbol.alignToGrid(width / 2, 'ceil');
      height = icon.height + 2 * space;
      height = 2 * symbol.alignToGrid(height / 2, 'ceil');
      pinLength = (ref = settings.pinLength) != null ? ref : 5;
      pinLength = symbol.alignToGrid(pinLength, 'ceil');
      symbol.attribute('refDes', {
        x: 0,
        y: -height / 2 - settings.space.attribute,
        halign: 'center',
        valign: 'bottom'
      }).attribute('name', {
        x: settings.space.attribute,
        y: height / 2 + settings.space.attribute,
        halign: 'left',
        valign: 'top'
      }).pin({
        number: left.number,
        name: left.name,
        x: -width / 2 - pinLength,
        y: 0,
        length: pinLength,
        orientation: 'right',
        passive: true
      }).pin({
        number: middle.number,
        name: middle.name,
        x: 0,
        y: height / 2 + pinLength,
        length: pinLength,
        orientation: 'up',
        passive: true
      }).pin({
        number: right.number,
        name: right.name,
        x: width / 2 + pinLength,
        y: 0,
        length: pinLength,
        orientation: 'left',
        passive: true
      });
      x1 = -width / 4;
      x2 = width / 4;
      symbol.lineWidth(settings.lineWidth.thick).rectangle(-width / 2, -height / 2, width / 2, height / 2, 'foreground');
      icon.draw(x1, 0, rotateLeft);
      icon.draw(x2, 0, rotateRight);
      r = settings.lineWidth.thick;
      return symbol.line(-width / 2, 0, x1 - icon.width / 2, 0).line(x1 + icon.width / 2, 0, x2 - icon.width / 2, 0).line(x2 + icon.width / 2, 0, width / 2, 0).line(0, 0, 0, height / 2).circle(0, 0, r, 'background');
    }
  };

}).call(this);
